package org.example.app_sb.controller;

import org.example.app_sb.entity.Person;
import org.example.app_sb.entity.PersonHealth;

import org.example.app_sb.service.HealthService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@RestController
public class HealthController {
    @Autowired
    private HealthService healthService;

    @GetMapping("/api/ehrSet_805")
    public String saveHealthRecord(
            @RequestParam String sfz_id,
            @RequestParam String name,
            @RequestParam String gender,
            @RequestParam String emr,
            @RequestParam int sbp,
            @RequestParam int dbp) {
        healthService.saveOrUpdatePerson(sfz_id, name, gender, emr);
        healthService.saveHealthData(sfz_id, sbp, dbp);
        return name;
    }

    @GetMapping("/api/ehrGet_805")
    public Object getLatestHealthRecord(@RequestParam String sfz_id) {
        PersonHealth record = healthService.getLatestHealthRecord(sfz_id);
        return record != null ? record : "未找到健康档案";
    }
}
