package org.example.app_sb.service;

import org.example.app_sb.entity.Person;
import org.example.app_sb.entity.PersonHealth;
import org.example.app_sb.repository.PersonHealthRepository;
import org.example.app_sb.repository.PersonRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.time.Instant;
import java.util.Optional;

@Service
public class HealthService {
    @Autowired
    private PersonRepository personRepository;

    @Autowired
    private PersonHealthRepository personHealthRepository;

    public void saveOrUpdatePerson(String sfzId, String name, String gender, String emr) {
        Person person = personRepository.findById(sfzId).orElse(new Person());
        int now = (int) Instant.now().getEpochSecond();
        person.setSfzId(sfzId);
        person.setName(name);
        person.setGender(gender);
        person.setEmr(emr);
        person.setUpdateTime(now);
        if (person.getCreateTime() == 0) {
            person.setCreateTime(now);
        }
        personRepository.save(person);
    }

    public void saveHealthData(String sfzId, int sbp, int dbp) {
        PersonHealth health = new PersonHealth();
        health.setId(String.valueOf(Instant.now().toEpochMilli()));
        health.setSfzId(sfzId);
        health.setSbp(sbp);
        health.setDbp(dbp);
        health.setCreateTime((int) Instant.now().getEpochSecond());
        personHealthRepository.save(health);
    }

    public PersonHealth getLatestHealthRecord(String sfzId) {
        return personHealthRepository.findBySfzIdOrderByCreateTimeDesc(sfzId).stream().findFirst().orElse(null);
    }
}
