package org.example.app_sb.service;

import org.example.app_sb.entity.User;
import org.example.app_sb.repository.UserRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

@Service
public class UserService {
    @Autowired
    private UserRepository userRepository;

    @Transactional
    public String setUser(String name, String address) {
        User user = userRepository.findByName(name);
        if (user != null) {
            user.setAddress(address);
            userRepository.save(user);
            return "Updated successfully!";
        } else {
            User newUser = new User();
            newUser.setName(name);
            newUser.setAddress(address);
            newUser.setPassword("default_password");
            userRepository.save(newUser);
            return "Inserted successfully!";
        }
    }

    public String getUserAddress(String name) {
        User user = userRepository.findByName(name);
        return user != null ? user.getAddress() : "User not found!";
    }

    // MD5 加密
    public String encryptPassword(String password) {
        try {
            MessageDigest md = MessageDigest.getInstance("MD5");
            byte[] digest = md.digest(password.getBytes());
            StringBuilder sb = new StringBuilder();
            for (byte b : digest) {
                sb.append(String.format("%02x", b));
            }
            return sb.toString();
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException("Error encrypting password", e);
        }
    }

    // 注册或更新密码
    @Transactional
    public String register(String name, String password) {
        User user = userRepository.findByName(name);
        String encryptedPassword = encryptPassword(password);
        if (user != null) {
            user.setPassword(encryptedPassword);
            userRepository.save(user);
            return "用户密码修改成功";
        } else {
            User newUser = new User();
            newUser.setName(name);
            newUser.setPassword(encryptedPassword);
            userRepository.save(newUser);
            return "新用户注册成功";
        }
    }

    // 登录
    public String login(String name, String password) {
        User user = userRepository.findByName(name);
        if (user != null && user.getPassword().equals(encryptPassword(password))) {
            return "登录成功";
        }
        return "登录失败";
    }

    // 登录验证
    public boolean validateLogin(String name, String password) {
        User user = userRepository.findByName(name);
        return user != null && user.getPassword().equals(encryptPassword(password));
    }

}
